#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define nn (4096)

//#include <mkl.h>
#include <gsl/gsl_cblas.h>

double a[nn][nn];       /** matrici**/
double b[nn][nn];
double c[nn][nn];

int main()
{
  int k, i, j, ii, jj;
  double somma;
  float time1, time2, dub_time;
  char transpose1='n';
  char transpose2='n';
  char transpose3='n';
  double alfa=1.,beta=0.;
  int n=nn;

  printf("===============================\n");
  printf("prodotto di matrici in doppia precisione \n");
  printf("dimensioni %d \n",nn );
  printf("===============================\n");
  printf("Inizializzazione \n");

  /* initialize matrix */
  time1 = clock();
  for (j = 0; j < nn; j++)
    {
    for (i = 0; i < nn; i++)
      {
      a[j][i] = ((double)rand())/((double)RAND_MAX);
      b[j][i] = ((double)rand())/((double)RAND_MAX);
      c[j][i] = 0.0L;		
      }
    }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("Tempo impiegato per inizializzare \n");
  printf("Tempo -----------------> %f \n", dub_time);

  time1 = clock();
/*  c_ij = c_ij + a_ik * b_kj                                  */ 
  cblas_dgemm(CblasRowMajor, CblasNoTrans, CblasNoTrans, nn, nn, nn, 1., (double*)a, nn, (double*)b, nn, 0., (double*)c, nn);

//  dgemm_(&transpose1, &transpose2, &n, &n, &n, &alfa, (double*)a, &n, (double*)b, &n, &beta, (double*)c, &n);

/*  qui sopra va completato il programma, prodotto righe per colonne */
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("===============================\n");
  printf("Tempo per prodotto classico \n");
  printf("Tempo -----------------> %f \n", dub_time);
  printf("Mflops ----------------> %f \n", 
          2.0*nn*nn*nn/(1000*1000*dub_time));

  /* semplice controllo */
  somma = 0.0;
  for (i = 0; i < nn; i++)
     for (j = 0; j < nn; j++)
         somma = somma + c[i][j];
  printf("Controllo -------------> %f \n", somma);
  printf("Controllo -------------> %f \n", c[nn/2][nn/2]);

  return 0;  
}
